

<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>posydon.active_learning.psy_cris.synthetic_data.synth_data_3D &mdash; posydon 0+untagged.3754.gf69f455.dirty documentation</title>
  

  
  <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../../../_static/pygments.css" type="text/css" />

  
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="../../../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../../../" src="../../../../../_static/documentation_options.js"></script>
        <script src="../../../../../_static/jquery.js"></script>
        <script src="../../../../../_static/underscore.js"></script>
        <script src="../../../../../_static/doctools.js"></script>
        <script src="../../../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>

    
    <link rel="index" title="Index" href="../../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../../../index.html" class="icon icon-home"> posydon
          

          
          </a>

          
            
            
              <div class="version">
                0+untagged.3754.gf69f455.dirty
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../../install/index.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../run_mesa_grids/inifile.html">Configuration files for POSYDON</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../run_mesa_grids/dynamic/dynamic.html">Run a Dynamic MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../run_mesa_grids/fixed/fixed.html">Run a Fixed MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../PSyGrid/PSyGrid.html">The PSyGrid Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../PSyGrid/plot2D/plot2D.html">Showcase of 2D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../PSyGrid/plot1D/plot1D.html">Showcase of 1D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../SingleStar/SingleStar.html">The Single Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../BinaryStar/BinaryStar.html">The Binary Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../visualization/VH_diagram.html">Van den Heuvel diagrams</a></li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../../index.html">posydon</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../../../index.html" class="icon icon-home"></a> &raquo;</li>
        
          <li><a href="../../../../index.html">Module code</a> &raquo;</li>
        
      <li>posydon.active_learning.psy_cris.synthetic_data.synth_data_3D</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for posydon.active_learning.psy_cris.synthetic_data.synth_data_3D</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="k">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>

<div class="viewcode-block" id="func_1"><a class="viewcode-back" href="../../../../../api/posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.html#posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.func_1">[docs]</a><span class="k">def</span> <span class="nf">func_1</span><span class="p">(</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">,</span><span class="n">z</span><span class="p">):</span>
    <span class="c1"># Spheroid centered at [x,y]=[-1,1]</span>
    <span class="n">radius</span> <span class="o">=</span> <span class="mi">1</span><span class="p">;</span> <span class="n">a</span> <span class="o">=</span> <span class="mf">1.2</span><span class="p">;</span> <span class="n">b</span> <span class="o">=</span> <span class="mi">2</span><span class="p">;</span> <span class="n">c</span> <span class="o">=</span> <span class="mf">0.8</span>
    <span class="k">return</span>  <span class="p">(</span> <span class="p">(</span><span class="n">x</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span><span class="o">/</span><span class="n">a</span> <span class="p">)</span><span class="o">**</span><span class="mi">2</span> <span class="o">+</span> <span class="p">(</span> <span class="p">(</span><span class="n">y</span><span class="o">-</span><span class="mi">1</span><span class="p">)</span><span class="o">/</span><span class="n">b</span> <span class="p">)</span><span class="o">**</span><span class="mi">2</span> <span class="o">+</span> <span class="p">(</span> <span class="n">z</span><span class="o">/</span><span class="n">c</span> <span class="p">)</span><span class="o">**</span><span class="mi">2</span> <span class="o">-</span> <span class="n">radius</span><span class="o">**</span><span class="mi">2</span></div>

<div class="viewcode-block" id="func_2"><a class="viewcode-back" href="../../../../../api/posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.html#posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.func_2">[docs]</a><span class="k">def</span> <span class="nf">func_2</span><span class="p">(</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">,</span><span class="n">z</span><span class="p">):</span>
    <span class="c1"># Modified Rosenbrock function</span>
    <span class="n">a</span> <span class="o">=</span> <span class="mi">1</span><span class="p">;</span> <span class="n">b</span> <span class="o">=</span> <span class="mi">3</span><span class="p">;</span> <span class="n">c</span> <span class="o">=</span> <span class="nb">abs</span><span class="p">(</span><span class="n">z</span><span class="p">)</span> <span class="p">;</span>
    <span class="n">rosenbrock_func</span> <span class="o">=</span> <span class="p">(</span><span class="n">a</span><span class="o">-</span><span class="n">x</span><span class="p">)</span><span class="o">**</span><span class="mi">2</span> <span class="o">+</span> <span class="n">b</span><span class="o">*</span><span class="p">(</span><span class="n">y</span><span class="o">-</span><span class="n">x</span><span class="o">**</span><span class="mi">2</span><span class="p">)</span><span class="o">**</span><span class="mi">2</span>
    <span class="k">return</span> <span class="n">rosenbrock_func</span> <span class="o">+</span> <span class="n">c</span><span class="o">*</span><span class="p">(</span><span class="n">x</span><span class="o">-</span><span class="n">z</span><span class="p">)</span><span class="o">**</span><span class="mi">2</span></div>

<div class="viewcode-block" id="func_3"><a class="viewcode-back" href="../../../../../api/posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.html#posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.func_3">[docs]</a><span class="k">def</span> <span class="nf">func_3</span><span class="p">(</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">,</span><span class="n">z</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">sin</span><span class="p">(</span> <span class="p">(</span><span class="n">x</span><span class="o">-</span><span class="mf">0.25</span><span class="p">)</span> <span class="p">)</span> <span class="o">+</span> <span class="p">(</span><span class="n">y</span><span class="p">)</span><span class="o">*</span><span class="n">z</span></div>

<div class="viewcode-block" id="func_4"><a class="viewcode-back" href="../../../../../api/posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.html#posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.func_4">[docs]</a><span class="k">def</span> <span class="nf">func_4</span><span class="p">(</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">,</span><span class="n">z</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span> <span class="n">z</span> <span class="o">&lt;</span> <span class="mi">0</span><span class="p">,</span>  <span class="nb">abs</span><span class="p">((</span><span class="n">x</span><span class="p">)</span><span class="o">**</span><span class="mi">3</span><span class="o">-</span><span class="p">(</span><span class="n">y</span><span class="p">)</span><span class="o">**</span><span class="mi">3</span><span class="p">)</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">exp</span><span class="p">(</span><span class="o">-</span><span class="n">z</span><span class="p">),</span> <span class="mi">0</span> <span class="p">)</span></div>

<div class="viewcode-block" id="func_5"><a class="viewcode-back" href="../../../../../api/posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.html#posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.func_5">[docs]</a><span class="k">def</span> <span class="nf">func_5</span><span class="p">(</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">,</span><span class="n">z</span><span class="p">):</span>
    <span class="c1"># Spheroid centered at [x,y,z]=[0.5,0.5,0.85]</span>
    <span class="n">radius</span> <span class="o">=</span> <span class="mf">0.2</span><span class="p">;</span> <span class="n">a</span> <span class="o">=</span> <span class="mf">0.6</span><span class="p">;</span> <span class="n">b</span> <span class="o">=</span> <span class="mf">0.2</span><span class="p">;</span> <span class="n">c</span> <span class="o">=</span> <span class="mf">0.3</span><span class="p">;</span>
    <span class="k">return</span> <span class="p">((</span><span class="n">x</span><span class="o">-</span><span class="mf">0.5</span><span class="p">)</span><span class="o">/</span><span class="n">a</span> <span class="p">)</span><span class="o">**</span><span class="mi">2</span><span class="o">+</span><span class="p">(</span> <span class="p">(</span><span class="n">y</span><span class="o">-</span><span class="mf">0.5</span><span class="p">)</span><span class="o">/</span><span class="n">b</span> <span class="p">)</span><span class="o">**</span><span class="mi">2</span><span class="o">+</span><span class="p">(</span> <span class="p">(</span><span class="n">z</span><span class="o">-</span><span class="mf">0.85</span><span class="p">)</span><span class="o">/</span><span class="n">c</span> <span class="p">)</span><span class="o">**</span><span class="mi">2</span> <span class="o">-</span> <span class="n">radius</span><span class="o">**</span><span class="mi">2</span></div>

<div class="viewcode-block" id="analytic_classification_3D"><a class="viewcode-back" href="../../../../../api/posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.html#posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.analytic_classification_3D">[docs]</a><span class="k">def</span> <span class="nf">analytic_classification_3D</span><span class="p">(</span> <span class="n">X</span><span class="p">,</span> <span class="n">Y</span><span class="p">,</span> <span class="n">Z</span><span class="p">,</span> <span class="n">f_splits</span><span class="o">=</span><span class="p">[</span><span class="mi">1</span><span class="p">,</span> <span class="mf">2.5</span><span class="p">,</span><span class="o">-</span><span class="mf">0.5</span><span class="p">,</span> <span class="mf">1.8</span><span class="p">,</span> <span class="mf">0.3</span><span class="p">]):</span>
    <span class="sd">&quot;&quot;&quot;Unique classes 1,2,3,4,6,8 for a total of 6 classes. This nicely matches</span>
<span class="sd">    the colormap Dark2 for plotting.&quot;&quot;&quot;</span>
    <span class="n">ret_f1</span> <span class="o">=</span> <span class="n">func_1</span><span class="p">(</span><span class="n">X</span><span class="p">,</span><span class="n">Y</span><span class="p">,</span><span class="n">Z</span><span class="p">)</span>
    <span class="n">ret_f2</span> <span class="o">=</span> <span class="n">func_2</span><span class="p">(</span><span class="n">X</span><span class="p">,</span><span class="n">Y</span><span class="p">,</span><span class="n">Z</span><span class="p">)</span>
    <span class="n">ret_f3</span> <span class="o">=</span> <span class="n">func_3</span><span class="p">(</span><span class="n">X</span><span class="p">,</span><span class="n">Y</span><span class="p">,</span><span class="n">Z</span><span class="p">)</span>
    <span class="n">ret_f4</span> <span class="o">=</span> <span class="n">func_4</span><span class="p">(</span><span class="n">X</span><span class="p">,</span><span class="n">Y</span><span class="p">,</span><span class="n">Z</span><span class="p">)</span>
    <span class="n">ret_f5</span> <span class="o">=</span> <span class="n">func_5</span><span class="p">(</span><span class="n">X</span><span class="p">,</span><span class="n">Y</span><span class="p">,</span><span class="n">Z</span><span class="p">)</span>

    <span class="n">where_above_1</span> <span class="o">=</span> <span class="n">ret_f1</span> <span class="o">&gt;</span> <span class="n">f_splits</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
    <span class="n">where_above_2</span> <span class="o">=</span> <span class="n">ret_f2</span> <span class="o">&gt;</span> <span class="n">f_splits</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
    <span class="n">where_above_3</span> <span class="o">=</span> <span class="n">ret_f3</span> <span class="o">&gt;</span> <span class="n">f_splits</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span>
    <span class="n">where_above_4</span> <span class="o">=</span> <span class="n">ret_f4</span> <span class="o">&gt;</span> <span class="n">f_splits</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span>
    <span class="n">where_above_5</span> <span class="o">=</span> <span class="n">ret_f5</span> <span class="o">&gt;</span> <span class="n">f_splits</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span>

    <span class="c1"># First layer - purple, yellow</span>
    <span class="n">base_class</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span> <span class="n">where_above_3</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="mi">6</span><span class="p">)</span>

    <span class="c1"># Second layer - gray</span>
    <span class="n">base_class</span><span class="p">[</span> <span class="n">where_above_2</span> <span class="p">]</span> <span class="o">=</span> <span class="mi">8</span>

    <span class="c1"># Third layer - green</span>
    <span class="n">combined_val</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">logical_and</span><span class="p">(</span> <span class="n">where_above_1</span><span class="p">,</span> <span class="n">where_above_2</span> <span class="p">)</span> <span class="c1"># intersect with gray</span>
    <span class="n">base_class</span><span class="p">[</span> <span class="n">combined_val</span> <span class="p">]</span> <span class="o">=</span> <span class="mi">1</span>

    <span class="c1"># Fourth layer - pink</span>
    <span class="n">base_class</span><span class="p">[</span> <span class="n">where_above_4</span> <span class="p">]</span> <span class="o">=</span> <span class="mi">4</span>

    <span class="c1"># Fifth layer - orange</span>
    <span class="n">base_class</span><span class="p">[</span> <span class="n">np</span><span class="o">.</span><span class="n">invert</span><span class="p">(</span><span class="n">where_above_5</span><span class="p">)</span> <span class="p">]</span> <span class="o">=</span> <span class="mi">2</span>
    <span class="k">return</span> <span class="n">base_class</span></div>

<div class="viewcode-block" id="analytic_regression_3D"><a class="viewcode-back" href="../../../../../api/posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.html#posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.analytic_regression_3D">[docs]</a><span class="k">def</span> <span class="nf">analytic_regression_3D</span><span class="p">(</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">,</span><span class="n">z</span><span class="p">):</span>
    <span class="c1"># Something simple to start with</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">sin</span><span class="p">(</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">x</span><span class="o">**</span><span class="mi">2</span> <span class="o">+</span> <span class="n">y</span><span class="o">**</span><span class="mi">2</span> <span class="o">+</span> <span class="n">z</span><span class="o">**</span><span class="mi">2</span><span class="p">)</span> <span class="o">*</span> <span class="mi">2</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">pi</span><span class="o">/</span><span class="mf">0.75</span> <span class="p">)</span></div>


<div class="viewcode-block" id="get_raw_output_3D"><a class="viewcode-back" href="../../../../../api/posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.html#posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.get_raw_output_3D">[docs]</a><span class="k">def</span> <span class="nf">get_raw_output_3D</span><span class="p">(</span><span class="n">X</span><span class="p">,</span><span class="n">Y</span><span class="p">,</span><span class="n">Z</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Get the raw output for classification and regression for</span>
<span class="sd">    the 3D synthetic data set. Unique classes include the</span>
<span class="sd">    following [1,2,3,4,6,8].</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    classification_data : ndarray</span>
<span class="sd">        Class data (unique integers) in 3d classification space.</span>
<span class="sd">    regression_data : ndarray</span>
<span class="sd">        Regression output frmo 3d function.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span> <span class="n">X</span><span class="p">,</span> <span class="p">(</span><span class="nb">float</span><span class="p">,</span><span class="nb">int</span><span class="p">)</span> <span class="p">):</span>
        <span class="n">X</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">X</span><span class="p">]);</span> <span class="n">Y</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">Y</span><span class="p">]);</span> <span class="n">Z</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">Z</span><span class="p">])</span>
    <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span> <span class="n">X</span><span class="p">,</span> <span class="nb">list</span> <span class="p">):</span>
        <span class="n">X</span><span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">X</span><span class="p">);</span> <span class="n">Y</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">Y</span><span class="p">);</span> <span class="n">Z</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">Z</span><span class="p">)</span>

    <span class="n">classification_data</span> <span class="o">=</span> <span class="n">analytic_classification_3D</span><span class="p">(</span><span class="n">X</span><span class="p">,</span><span class="n">Y</span><span class="p">,</span><span class="n">Z</span><span class="p">)</span>
    <span class="n">regression_data</span> <span class="o">=</span> <span class="n">analytic_regression_3D</span><span class="p">(</span><span class="n">X</span><span class="p">,</span><span class="n">Y</span><span class="p">,</span><span class="n">Z</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">classification_data</span><span class="p">,</span> <span class="n">regression_data</span></div>


<div class="viewcode-block" id="get_output_3D"><a class="viewcode-back" href="../../../../../api/posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.html#posydon.active_learning.psy_cris.synthetic_data.synth_data_3D.get_output_3D">[docs]</a><span class="k">def</span> <span class="nf">get_output_3D</span><span class="p">(</span><span class="n">X</span><span class="p">,</span><span class="n">Y</span><span class="p">,</span><span class="n">Z</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Takes input points (X,Y,Z) in 3D and returns a DataFrame with the</span>
<span class="sd">    corresponding 3D classification and regression functions.</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    data_frame : DataFrame</span>
<span class="sd">        Pandas dataframe including inputs, class, and outputs.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span> <span class="n">X</span><span class="p">,</span> <span class="p">(</span><span class="nb">float</span><span class="p">,</span><span class="nb">int</span><span class="p">)</span> <span class="p">):</span>
        <span class="n">X</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">X</span><span class="p">]);</span> <span class="n">Y</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">Y</span><span class="p">]);</span> <span class="n">Z</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">Z</span><span class="p">])</span>
    <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span> <span class="n">X</span><span class="p">,</span> <span class="nb">list</span> <span class="p">):</span>
        <span class="n">X</span><span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">X</span><span class="p">);</span> <span class="n">Y</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">Y</span><span class="p">);</span> <span class="n">Z</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">Z</span><span class="p">)</span>

    <span class="n">classification_data</span><span class="p">,</span> <span class="n">regression_data</span> <span class="o">=</span> <span class="n">get_raw_output_3D</span><span class="p">(</span><span class="n">X</span><span class="p">,</span><span class="n">Y</span><span class="p">,</span><span class="n">Z</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">X</span><span class="o">.</span><span class="n">ndim</span> <span class="o">&gt;</span> <span class="mi">1</span> <span class="ow">or</span> <span class="n">Y</span><span class="o">.</span><span class="n">ndim</span> <span class="o">&gt;</span> <span class="mi">1</span> <span class="ow">or</span> <span class="n">Z</span><span class="o">.</span><span class="n">ndim</span> <span class="o">&gt;</span> <span class="mi">1</span><span class="p">:</span>
        <span class="n">classification_data</span> <span class="o">=</span> <span class="n">classification_data</span><span class="o">.</span><span class="n">flatten</span><span class="p">()</span>
        <span class="n">regression_data</span> <span class="o">=</span> <span class="n">regression_data</span><span class="o">.</span><span class="n">flatten</span><span class="p">()</span>
        <span class="n">X</span><span class="o">=</span><span class="n">X</span><span class="o">.</span><span class="n">flatten</span><span class="p">();</span> <span class="n">Y</span><span class="o">=</span><span class="n">Y</span><span class="o">.</span><span class="n">flatten</span><span class="p">();</span> <span class="n">Z</span><span class="o">=</span><span class="n">Z</span><span class="o">.</span><span class="n">flatten</span><span class="p">()</span>
    <span class="n">data_frame</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">()</span>
    <span class="n">data_frame</span><span class="p">[</span><span class="s2">&quot;input_1&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">X</span>
    <span class="n">data_frame</span><span class="p">[</span><span class="s2">&quot;input_2&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">Y</span>
    <span class="n">data_frame</span><span class="p">[</span><span class="s2">&quot;input_3&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">Z</span>
    <span class="n">data_frame</span><span class="p">[</span><span class="s2">&quot;class&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">classification_data</span><span class="o">.</span><span class="n">flatten</span><span class="p">()</span>
    <span class="n">data_frame</span><span class="p">[</span><span class="s2">&quot;output_1&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">regression_data</span><span class="o">.</span><span class="n">flatten</span><span class="p">()</span>
    <span class="k">return</span> <span class="n">data_frame</span></div>

<span class="c1"># EXAMPLE</span>
<span class="c1"># x_vals = np.linspace(-1,1,15)</span>
<span class="c1"># X, Y, Z = np.meshgrid( x_vals, x_vals+0.01, x_vals-0.02, indexing=&#39;ij&#39;)</span>
<span class="c1"># pd_data = get_output_3D( X,Y,Z )</span>
<span class="c1"># print( pd_data )</span>



<span class="c1"># -----------------------------------------------------------------------------</span>
<span class="c1">###########################</span>
<span class="c1">##        PLOTTING       ##</span>
<span class="c1">###########################</span>

<span class="k">if</span> <span class="p">(</span><span class="vm">__name__</span> <span class="o">==</span> <span class="s2">&quot;main&quot;</span><span class="p">):</span>

    <span class="c1"># SLICE PLOTS</span>
    <span class="n">all_Z_vals</span> <span class="o">=</span> <span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="o">-</span><span class="mf">0.5</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mf">0.5</span><span class="p">,</span> <span class="mi">1</span><span class="p">]</span>
    <span class="n">fig</span><span class="p">,</span> <span class="p">(</span><span class="n">subs_xy</span><span class="p">,</span> <span class="n">subs_xz</span><span class="p">)</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">nrows</span> <span class="o">=</span> <span class="mi">2</span><span class="p">,</span> <span class="n">ncols</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">all_Z_vals</span><span class="p">),</span>
                             <span class="n">figsize</span><span class="o">=</span><span class="p">(</span> <span class="mi">4</span><span class="o">*</span><span class="nb">len</span><span class="p">(</span><span class="n">all_Z_vals</span><span class="p">),</span> <span class="mf">7.5</span><span class="p">),</span> <span class="n">dpi</span><span class="o">=</span><span class="mi">50</span> <span class="p">)</span>

    <span class="k">for</span> <span class="n">ct</span><span class="p">,</span> <span class="n">zed_val</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">all_Z_vals</span><span class="p">):</span>
        <span class="n">N</span> <span class="o">=</span> <span class="mi">90</span>
        <span class="c1"># X-Y slice</span>
        <span class="n">X</span><span class="p">,</span> <span class="n">Y</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">meshgrid</span><span class="p">(</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="mi">1</span><span class="p">,</span><span class="n">N</span><span class="p">),</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="mi">1</span><span class="p">,</span><span class="n">N</span><span class="p">)</span> <span class="p">)</span>
        <span class="n">Z</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">ones</span><span class="p">(</span> <span class="n">X</span><span class="o">.</span><span class="n">shape</span> <span class="p">)</span> <span class="o">*</span> <span class="n">zed_val</span>
        <span class="n">f_out</span> <span class="o">=</span> <span class="n">analytic_classification_3D</span><span class="p">(</span> <span class="n">X</span><span class="p">,</span> <span class="n">Y</span><span class="p">,</span> <span class="n">Z</span> <span class="p">)</span>

        <span class="n">image</span> <span class="o">=</span> <span class="n">subs_xy</span><span class="p">[</span><span class="n">ct</span><span class="p">]</span><span class="o">.</span><span class="n">pcolor</span><span class="p">(</span> <span class="n">X</span><span class="p">,</span> <span class="n">Y</span><span class="p">,</span> <span class="n">f_out</span><span class="p">,</span>
                                     <span class="n">cmap</span><span class="o">=</span><span class="s2">&quot;Dark2&quot;</span><span class="p">,</span> <span class="n">vmin</span><span class="o">=</span><span class="mf">0.5</span><span class="p">,</span> <span class="n">vmax</span><span class="o">=</span><span class="mf">8.5</span> <span class="p">)</span>
        <span class="n">subs_xy</span><span class="p">[</span><span class="n">ct</span><span class="p">]</span><span class="o">.</span><span class="n">set_title</span><span class="p">(</span><span class="s2">&quot;z = </span><span class="si">{:.2f}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">zed_val</span><span class="p">),</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">14</span> <span class="p">)</span>

        <span class="c1"># X-Z slice</span>
        <span class="n">X</span><span class="p">,</span> <span class="n">Z</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">meshgrid</span><span class="p">(</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="mi">1</span><span class="p">,</span><span class="n">N</span><span class="p">),</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="mi">1</span><span class="p">,</span><span class="n">N</span><span class="p">)</span> <span class="p">)</span>
        <span class="n">Y</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">ones</span><span class="p">(</span> <span class="n">X</span><span class="o">.</span><span class="n">shape</span> <span class="p">)</span> <span class="o">*</span> <span class="n">zed_val</span>
        <span class="n">f_out_2</span> <span class="o">=</span> <span class="n">analytic_classification_3D</span><span class="p">(</span> <span class="n">X</span><span class="p">,</span> <span class="n">Y</span><span class="p">,</span> <span class="n">Z</span> <span class="p">)</span>
        <span class="n">image</span> <span class="o">=</span> <span class="n">subs_xz</span><span class="p">[</span><span class="n">ct</span><span class="p">]</span><span class="o">.</span><span class="n">pcolor</span><span class="p">(</span> <span class="n">X</span><span class="p">,</span> <span class="n">Z</span><span class="p">,</span> <span class="n">f_out_2</span><span class="p">,</span>
                                   <span class="n">cmap</span><span class="o">=</span><span class="s2">&quot;Dark2&quot;</span><span class="p">,</span> <span class="n">vmin</span><span class="o">=</span><span class="mf">0.5</span><span class="p">,</span> <span class="n">vmax</span><span class="o">=</span><span class="mf">8.5</span> <span class="p">)</span>
        <span class="n">subs_xz</span><span class="p">[</span><span class="n">ct</span><span class="p">]</span><span class="o">.</span><span class="n">set_title</span><span class="p">(</span><span class="s2">&quot;y = </span><span class="si">{:.2f}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">zed_val</span><span class="p">),</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">14</span> <span class="p">)</span>

        <span class="c1"># horizontal lines</span>
        <span class="n">subs_xy</span><span class="p">[</span><span class="n">ct</span><span class="p">]</span><span class="o">.</span><span class="n">hlines</span><span class="p">(</span> <span class="n">all_Z_vals</span><span class="p">,</span> <span class="n">xmin</span><span class="o">=-</span><span class="mi">1</span><span class="p">,</span> <span class="n">xmax</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s2">&quot;w&quot;</span><span class="p">,</span> <span class="n">linestyle</span><span class="o">=</span><span class="s1">&#39;--&#39;</span><span class="p">,</span> <span class="n">alpha</span> <span class="o">=</span><span class="mf">0.35</span> <span class="p">)</span>

    <span class="c1"># split subplot into two exes and change one to cbar</span>
    <span class="kn">from</span> <span class="nn">mpl_toolkits.axes_grid1</span> <span class="kn">import</span> <span class="n">make_axes_locatable</span>
    <span class="k">for</span> <span class="n">sub_plot_ax</span> <span class="ow">in</span> <span class="p">[</span><span class="n">subs_xy</span><span class="p">[</span><span class="n">ct</span><span class="p">],</span> <span class="n">subs_xz</span><span class="p">[</span><span class="n">ct</span><span class="p">]]:</span>
        <span class="n">divider</span> <span class="o">=</span> <span class="n">make_axes_locatable</span><span class="p">(</span> <span class="n">sub_plot_ax</span> <span class="p">)</span>
        <span class="n">cax2</span> <span class="o">=</span> <span class="n">divider</span><span class="o">.</span><span class="n">append_axes</span><span class="p">(</span><span class="s2">&quot;right&quot;</span><span class="p">,</span> <span class="n">size</span><span class="o">=</span><span class="s2">&quot;5%&quot;</span><span class="p">,</span> <span class="n">pad</span><span class="o">=</span><span class="mf">0.1</span><span class="p">)</span>
        <span class="n">fig</span><span class="o">.</span><span class="n">colorbar</span><span class="p">(</span><span class="n">image</span><span class="p">,</span> <span class="n">cax</span><span class="o">=</span><span class="n">cax2</span><span class="p">)</span>

    <span class="n">subs_xy</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s2">&quot;Y&quot;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">15</span><span class="p">,</span> <span class="n">rotation</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
    <span class="n">subs_xz</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s2">&quot;Z&quot;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">15</span><span class="p">,</span> <span class="n">rotation</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">all_Z_vals</span><span class="p">)):</span>
        <span class="n">subs_xy</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">(</span><span class="s2">&quot;X&quot;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">15</span><span class="p">);</span>
        <span class="n">subs_xz</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">(</span><span class="s2">&quot;X&quot;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">15</span><span class="p">);</span>

    <span class="c1">#fig.colorbar(image, ax=subs_xy[ct])</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">subplots_adjust</span><span class="p">(</span><span class="n">hspace</span><span class="o">=</span><span class="mf">0.35</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>



    <span class="c1"># 3D Plots</span>
    <span class="kn">from</span> <span class="nn">matplotlib.cm</span> <span class="kn">import</span> <span class="n">get_cmap</span>

    <span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">()</span>
    <span class="n">ax</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">111</span><span class="p">,</span> <span class="n">projection</span><span class="o">=</span><span class="s1">&#39;3d&#39;</span><span class="p">)</span>
    <span class="n">n</span> <span class="o">=</span> <span class="mi">45</span>
    <span class="n">x_vals</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="mi">1</span><span class="p">,</span><span class="n">n</span><span class="p">)</span>
    <span class="n">y_vals</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="o">-</span><span class="mf">1.01</span><span class="p">,</span><span class="mi">1</span><span class="p">,</span><span class="n">n</span><span class="p">)</span>
    <span class="n">z_vals</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="mf">1.01</span><span class="p">,</span><span class="n">n</span><span class="p">)</span>
    <span class="n">X</span><span class="p">,</span> <span class="n">Y</span><span class="p">,</span> <span class="n">Z</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">meshgrid</span><span class="p">(</span> <span class="n">x_vals</span><span class="p">,</span> <span class="n">y_vals</span><span class="p">,</span> <span class="n">z_vals</span><span class="p">,</span> <span class="n">indexing</span><span class="o">=</span><span class="s1">&#39;ij&#39;</span><span class="p">)</span>
    <span class="n">test_f_out</span> <span class="o">=</span> <span class="n">analytic_classification_3D</span><span class="p">(</span> <span class="n">X</span><span class="p">,</span> <span class="n">Y</span><span class="p">,</span> <span class="n">Z</span> <span class="p">)</span>

    <span class="c1"># Plotting all points for a given class</span>
    <span class="c1"># 4, 1, 8, 3, 6, 2</span>
    <span class="k">for</span> <span class="n">ct</span><span class="p">,</span> <span class="n">number</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span> <span class="p">[</span><span class="mi">4</span><span class="p">,</span><span class="mi">6</span><span class="p">,</span><span class="mi">2</span><span class="p">]</span> <span class="p">):</span>
        <span class="n">cmap</span> <span class="o">=</span> <span class="n">get_cmap</span><span class="p">(</span><span class="s1">&#39;Dark2&#39;</span><span class="p">)</span>
        <span class="n">rgba</span> <span class="o">=</span> <span class="n">cmap</span><span class="p">(</span> <span class="n">number</span><span class="o">/</span><span class="mf">8.5</span> <span class="p">)</span>
        <span class="n">where_good_pts</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span> <span class="n">test_f_out</span> <span class="o">==</span> <span class="n">number</span> <span class="p">)</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span> <span class="n">X</span><span class="p">[</span><span class="n">where_good_pts</span><span class="p">],</span> <span class="n">Y</span><span class="p">[</span><span class="n">where_good_pts</span><span class="p">],</span> <span class="n">Z</span><span class="p">[</span><span class="n">where_good_pts</span><span class="p">],</span>
                   <span class="n">color</span><span class="o">=</span><span class="n">rgba</span><span class="p">,</span> <span class="n">alpha</span><span class="o">=</span><span class="mf">0.55</span><span class="p">,</span> <span class="n">s</span><span class="o">=</span><span class="mi">10</span> <span class="p">)</span>

    <span class="c1"># Plotting all points in a z slice</span>
    <span class="n">slice_zed_val</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="n">slice_val</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">argmin</span><span class="p">(</span> <span class="nb">abs</span><span class="p">(</span><span class="n">slice_zed_val</span><span class="o">-</span><span class="n">z_vals</span><span class="p">)</span> <span class="p">)</span>  <span class="c1"># which zed val</span>
    <span class="c1"># for ct, number in enumerate( np.unique(test_f_out) ):</span>
    <span class="c1">#     cmap = get_cmap(&#39;Dark2&#39;)</span>
    <span class="c1">#     rgba = cmap( number/8.5 )</span>
    <span class="c1">#     where_good_pts = np.where( test_f_out[:,:,slice_val] == number )</span>
    <span class="c1">#     ax.scatter( X[:,:,slice_val][where_good_pts],</span>
    <span class="c1">#                 Y[:,:,slice_val][where_good_pts],</span>
    <span class="c1">#                 Z[:,:,slice_val][where_good_pts],</span>
    <span class="c1">#                 color=rgba, alpha=0.85, s=10 )</span>

    <span class="n">ax</span><span class="o">.</span><span class="n">set_xlim3d</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="o">-</span><span class="mi">1</span><span class="p">);</span> <span class="n">ax</span><span class="o">.</span><span class="n">set_ylim3d</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="o">-</span><span class="mi">1</span><span class="p">);</span> <span class="n">ax</span><span class="o">.</span><span class="n">set_zlim3d</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="mi">1</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">(</span><span class="s1">&#39;X&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">15</span><span class="p">);</span> <span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s1">&#39;Y&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">15</span><span class="p">);</span> <span class="n">ax</span><span class="o">.</span><span class="n">set_zlabel</span><span class="p">(</span><span class="s1">&#39;Z&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">15</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">view_init</span><span class="p">(</span><span class="n">elev</span><span class="o">=</span><span class="mf">89.5</span><span class="p">,</span> <span class="n">azim</span><span class="o">=</span><span class="mi">90</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>





    <span class="c1"># Regression</span>

    <span class="n">x_vals</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="mi">1</span><span class="p">,</span><span class="mi">15</span><span class="p">)</span>
    <span class="n">X</span><span class="p">,</span> <span class="n">Y</span><span class="p">,</span> <span class="n">Z</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">meshgrid</span><span class="p">(</span> <span class="n">x_vals</span><span class="p">,</span> <span class="n">x_vals</span><span class="o">+</span><span class="mf">0.01</span><span class="p">,</span> <span class="n">x_vals</span><span class="o">-</span><span class="mf">0.02</span><span class="p">,</span> <span class="n">indexing</span><span class="o">=</span><span class="s1">&#39;ij&#39;</span><span class="p">)</span>
    <span class="n">pd_data</span> <span class="o">=</span> <span class="n">get_output_3D</span><span class="p">(</span> <span class="n">X</span><span class="p">,</span><span class="n">Y</span><span class="p">,</span><span class="n">Z</span> <span class="p">)</span>

    <span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">()</span>
    <span class="n">ax</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">111</span><span class="p">,</span> <span class="n">projection</span><span class="o">=</span><span class="s1">&#39;3d&#39;</span><span class="p">)</span>
    <span class="n">scatter_plot</span> <span class="o">=</span> <span class="n">ax</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span> <span class="n">X</span><span class="p">,</span> <span class="n">Y</span><span class="p">,</span> <span class="n">Z</span><span class="p">,</span> <span class="n">c</span><span class="o">=</span><span class="n">pd_data</span><span class="p">[</span><span class="s2">&quot;output_1&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">alpha</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">s</span><span class="o">=</span><span class="mi">10</span> <span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_xlim3d</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="o">-</span><span class="mi">1</span><span class="p">);</span> <span class="n">ax</span><span class="o">.</span><span class="n">set_ylim3d</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="o">-</span><span class="mi">1</span><span class="p">);</span> <span class="n">ax</span><span class="o">.</span><span class="n">set_zlim3d</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="mi">1</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">(</span><span class="s1">&#39;X&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">15</span><span class="p">);</span> <span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s1">&#39;Y&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">15</span><span class="p">);</span> <span class="n">ax</span><span class="o">.</span><span class="n">set_zlabel</span><span class="p">(</span><span class="s1">&#39;Z&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">15</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">view_init</span><span class="p">(</span><span class="n">elev</span><span class="o">=</span><span class="mf">89.5</span><span class="p">,</span> <span class="n">azim</span><span class="o">=</span><span class="mi">90</span><span class="p">)</span>

    <span class="n">fig</span><span class="o">.</span><span class="n">colorbar</span><span class="p">(</span><span class="n">scatter_plot</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
</pre></div>

           </div>
           
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2019, Tassos Fragkos.

    </p>
  </div>
    
    
    
    Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    
    provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>